import 'package:flutter/widgets.dart';

abstract class AppText extends Text {
  const AppText(
    super.text, {
    required super.style,
    super.key,
    super.textAlign,
    super.softWrap,
    super.maxLines,
    super.overflow,
  });

  AppText copyWith({
    String? text,
    TextStyle? style,
    TextAlign? textAlign,
    bool? softWrap,
    int? maxLines,
    TextOverflow? overflow,
  });

  AppText color(Color? color) {
    return copyWith(
      style: style?.copyWith(color: color),
    );
  }

  AppText decoration(TextDecoration decoration) {
    return copyWith(
      style: style?.copyWith(decoration: decoration),
    );
  }

  AppText align([TextAlign textAlign = TextAlign.center]) {
    return copyWith(
      textAlign: textAlign,
    );
  }

  // Font weight 300
  AppText light() {
    return copyWith(
      style: style?.copyWith(fontWeight: FontWeight.w300),
    );
  }

  /// Font weight 400
  AppText normal() {
    return copyWith(
      style: style?.copyWith(fontWeight: FontWeight.w400),
    );
  }

  /// Font weight 500
  AppText medium() {
    return copyWith(
      style: style?.copyWith(fontWeight: FontWeight.w500),
    );
  }

  /// Font weight 600
  AppText semiBold() {
    return copyWith(
      style: style?.copyWith(fontWeight: FontWeight.w600),
    );
  }

  /// Font weight 700
  AppText bold() {
    return copyWith(
      style: style?.copyWith(fontWeight: FontWeight.w700),
    );
  }
}
